// ADJUST.cpp : implementation file
//

#include "stdafx.h"
#include "VIDCAP01.h"
#include "ADJUST.h"
#include "VAL_USB.h"
#include  "VIDCAP01Dlg.h"
//#include  "DialogAdvancedControls.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CADJUST dialog

extern int m_FlashCapture;

CADJUST::CADJUST(CWnd* pParent /*=NULL*/)
	: CDialog(CADJUST::IDD, (pParent))
{
	m_pParent=(CVIDCAP01Dlg*)pParent;
	//{{AFX_DATA_INIT(CADJUST)
	m_RedOffsetstr = _T("");
	m_RedLabel = _T("");
	m_BlueOffsetstr = _T("");
	m_BlueLabel = _T("");
	m_Chromastr = _T("");
	m_ChromaLabel = _T("");
	m_Brightnessstr = _T("");
	m_Contraststr = _T("");
	m_RegisterNumber = 0;
	m_RegisterValue = 0;
	//}}AFX_DATA_INIT
   	
	if (Create(CADJUST::IDD,pParent))
	{
		// ** Creation succeeded so show the window
		ShowWindow(SW_SHOW);
	}
    
   
	
	CSliderCtrl* pSlider; 
   
    m_RedGainSliderDialog.SetRange(  -25,  25,TRUE );
    m_RedGainSliderDialog.SetPageSize(1);

	pSlider=(CSliderCtrl*)GetDlgItem(IDC_BLUEGAINSLIDER);
    pSlider->SetRange(  -25,  25,TRUE);
    pSlider->SetPageSize(1);

    pSlider=(CSliderCtrl*)GetDlgItem(IDC_CHROMASLIDER);
    pSlider->SetRange(  0,  127,TRUE);
    pSlider->SetPageSize(1);

	pSlider=(CSliderCtrl*)GetDlgItem(IDC_BRIGHTNESSSLIDER);
    pSlider->SetRange(  0,  127,TRUE);
    pSlider->SetPageSize(1);

	pSlider=(CSliderCtrl*)GetDlgItem(IDC_CONTRASTSLIDER);
    pSlider->SetRange(  0,  127,TRUE);
    pSlider->SetPageSize(1);
	
	//m_BlueGainSliderDialog.SetRange(0,127,TRUE);
	m_FGSharpnessSlider.SetRange(0,6,TRUE);
    m_FGSharpnessSlider.SetPageSize(1);
	SetControls();

	PositionDialog();       
}


void CADJUST::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CADJUST)
	DDX_Control(pDX, IDC_FMSHARPNESS, m_FGSharpnessSlider);
	DDX_Control(pDX, IDC_SHARPRADIO0, m_AdjustSharpness);
	DDX_Control(pDX, IDC_CONTRASTSLIDER, m_ContrastSliderDialog);
	DDX_Control(pDX, IDC_CHROMASLIDER, m_ChromaLevelDialog);
	DDX_Control(pDX, IDC_BRIGHTNESSSLIDER, m_BrightnessSliderDialog);
	DDX_Control(pDX, IDC_BLUEGAINSLIDER, m_BlueGainSliderDialog);
	DDX_Control(pDX, IDC_REDGAINSLIDER, m_RedGainSliderDialog);
	DDX_Text(pDX, IDC_STATICREDLEVEL, m_RedOffsetstr);
	DDX_Text(pDX, IDC_STATICREDLABEL, m_RedLabel);
	DDX_Text(pDX, IDC_STATICBLUELEVEL, m_BlueOffsetstr);
	DDX_Text(pDX, IDC_STATICBLUELABEL, m_BlueLabel);
	DDX_Text(pDX, IDC_STATICCHROMALEVEL, m_Chromastr);
	DDX_Text(pDX, IDC_STATICCHROMALABEL, m_ChromaLabel);
	DDX_Text(pDX, IDC_STATICBRIGHTNESSLEVEL, m_Brightnessstr);
	DDX_Text(pDX, IDC_STATICCONTRASTLEVEL, m_Contraststr);
	DDX_Text(pDX, IDC_REGISTERNUMBER, m_RegisterNumber);
	DDX_Text(pDX, IDC_REGISTERVALUE, m_RegisterValue);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CADJUST, CDialog)
	//{{AFX_MSG_MAP(CADJUST)
	ON_BN_CLICKED(IDC_CLOSEDIALOG, OnClosedialog)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SHARPRADIO0, OnSharpradio0)
	ON_BN_CLICKED(IDC_SHARPRADIO2, OnSharpradio2)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_SHARPRADIO3, OnSharpradio3)
	ON_BN_CLICKED(IDC_AUTOWHITEDIALOG, OnAutowhitedialog)
	ON_BN_CLICKED(IDC_WRITEREG, OnWritereg)
	ON_BN_CLICKED(IDC_SHARPRADIO1, OnSharpradio1)
	ON_BN_CLICKED(IDC_ADVANCEDADJUST, OnAdvancedadjust)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CADJUST message handlers

void CADJUST::OnClosedialog() 
{
	// TODO: Add your control notification handler code here
    
	SendMessage(WM_CLOSE);
	
}

extern CADJUST*  m_pAdjustDialog;
void CADJUST::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	m_pParent->SetWindowPos(NULL, MainRect.left, MainRect.top, 0, 0, SWP_NOSIZE || SWP_SHOWWINDOW );
	CDialog::OnClose();
	delete(this);
    m_pAdjustDialog=NULL;
	 //m_pParent->SetWindowPos(NULL, m_pParent->m_LeftPos, m_pParent->m_TopPos, 0, 0, SWP_NOSIZE || SWP_SHOWWINDOW );
}

void CADJUST::OnSharpradio0() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pParent->m_Sharpness=0;//m_AdjustSharpness;
}

void CADJUST::OnSharpradio2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pParent->m_Sharpness=2;//m_AdjustSharpness;
	
}


void CADJUST::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default  	
	int ColorLevel;

	UpdateData(TRUE);
    if ((pScrollBar->GetDlgCtrlID())==IDC_REDGAINSLIDER){ 
		if (m_pParent->m_FlashCapture == 1){
	        m_pParent->m_RedFlashOffset=m_RedGainSliderDialog.GetPos();
			m_RedOffsetstr.Format("%d",m_pParent->m_RedFlashOffset);
		}
		else{
	      m_pParent->m_RedPreviewOffset=m_RedGainSliderDialog.GetPos(); 
		  ColorLevel=m_pParent->m_RedPreviewOffset+ m_pParent->m_RedAutoWhite;
		  m_RedOffsetstr.Format("%d",m_pParent->m_RedPreviewOffset);
		  m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,ColorLevel, 0 );
	      m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETREDGAIN, 0 );
		}	
	}
	else
	  if ((pScrollBar->GetDlgCtrlID())==IDC_BLUEGAINSLIDER){ 
		if (m_pParent->m_FlashCapture == 1){
	       m_pParent->m_BlueFlashOffset=m_BlueGainSliderDialog.GetPos();
		   m_BlueOffsetstr.Format("%d",m_pParent->m_BlueFlashOffset);
	   }
	   else{
          m_pParent->m_BluePreviewOffset=m_BlueGainSliderDialog.GetPos(); 
		  ColorLevel=m_pParent->m_BluePreviewOffset+ m_pParent->m_BlueAutoWhite;
		  m_BlueOffsetstr.Format("%d",m_pParent->m_BluePreviewOffset);
		  m_pParent->m_pVc3Ctrl->Set(VC_CTRL_BLUE_BALANCE ,ColorLevel, 0 );
	      m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETBLUEGAIN, 0 );
	   }
	  }
	  else{
	   if ((pScrollBar->GetDlgCtrlID())==IDC_CHROMASLIDER){ 
		  if (m_pParent->m_FlashCapture == 1){
	       m_pParent->m_FlashChromaLevel=m_ChromaLevelDialog.GetPos();
		   m_Chromastr.Format("%d",m_ChromaLevelDialog.GetPos);
		  }
		  else{
		  m_pParent->m_ChromaLevel=m_ChromaLevelDialog.GetPos();
		  m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,m_ChromaLevelDialog.GetPos(), 0 );
	      m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETCHROMALEVEL, 0 );
		  m_Chromastr.Format("%d",m_ChromaLevelDialog.GetPos());		  

		  }
	   }  
       /*
	   else
		   if ((pScrollBar->GetDlgCtrlID())==IDC_BRIGHTNESSSLIDER){ 
	           m_pParent->m_Brightness = m_BrightnessSliderDialog.GetPos();
			   m_Brightnessstr.Format("%d",m_BrightnessSliderDialog.GetPos());
			   m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,m_BrightnessSliderDialog.GetPos(), 0 );
	           m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETBRIGHTNESSLEVEL, 0 );
		   }
	     else  
	         if ((pScrollBar->GetDlgCtrlID())==IDC_CONTRASTSLIDER){ 
	           m_pParent->m_Contrast = m_ContrastSliderDialog.GetPos();
			   m_Contraststr.Format("%d",m_ContrastSliderDialog.GetPos());			   	 
			   m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,m_ContrastSliderDialog.GetPos(), 0 );
	           m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETCONTRASTLEVEL, 0 );
		   }
	  */
	  }	  
	 
	UpdateData(FALSE);       	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

}

void CADJUST::OnSharpradio3() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pParent->m_Sharpness=3;//m_AdjustSharpness;
	
}

void CADJUST::SetControls()

{
	CButton* pButton;
	
	switch (m_pParent->m_Sharpness){
	case 0:
		   pButton=(CButton*)GetDlgItem(IDC_SHARPRADIO0);
		   pButton->SetCheck(1);
		   break;
    case 1:
		   pButton=(CButton*)GetDlgItem(IDC_SHARPRADIO1);
		   pButton->SetCheck(1);
		   break;

	case 2:
		   pButton=(CButton*)GetDlgItem(IDC_SHARPRADIO2);
		   pButton->SetCheck(1);
		   break;

    case 3:
		   pButton=(CButton*)GetDlgItem(IDC_SHARPRADIO3);
		   pButton->SetCheck(1);
		   break;
		   
	}


	
	if (m_pParent->m_FlashCapture==1){
		m_RedGainSliderDialog.SetPos(m_pParent->m_RedFlashOffset);
		m_BlueGainSliderDialog.SetPos(m_pParent->m_BlueFlashOffset);
		//m_AdjustSharpness=m_pParent->m_Sharpness ;
		m_ChromaLevelDialog.SetPos(m_pParent->m_FlashChromaLevel);		
		m_RedLabel="Flash Red Gain";
		m_BlueLabel="Flash Blue Gain";
		m_RedOffsetstr.Format("%d",m_RedGainSliderDialog.GetPos);
	    m_ChromaLabel="Flash Color Level";
		m_BlueOffsetstr.Format("%d",m_BlueGainSliderDialog.GetPos());
		m_Chromastr.Format("%d",m_ChromaLevelDialog.GetPos());
	}
	else{
		m_RedGainSliderDialog.SetPos(m_pParent->m_RedPreviewOffset);
		m_BlueGainSliderDialog.SetPos(m_pParent->m_BluePreviewOffset);
		//m_AdjustSharpness=m_pParent->m_Sharpness ;
		m_ChromaLevelDialog.SetPos(m_pParent->m_ChromaLevel);
		m_RedLabel="Preview Red Gain";
		m_BlueLabel="Preview Blue Gain";
		m_ChromaLabel="Preview Color Level";
		m_RedOffsetstr.Format("%d",m_RedGainSliderDialog.GetPos());
	    m_BlueOffsetstr.Format("%d",m_BlueGainSliderDialog.GetPos());
		m_Chromastr.Format("%d",m_ChromaLevelDialog.GetPos());
	}
	/*
	m_BrightnessSliderDialog.SetPos(m_pParent->m_Brightness);
	m_Brightnessstr.Format("%d",m_BrightnessSliderDialog);
	
	m_ContrastSliderDialog.SetPos(m_pParent->m_Contrast);
	m_Contraststr.Format("%d",m_ContrastSliderDialog);
	*/
	UpdateData(FALSE);
	
}

void CADJUST::PositionDialog()
{
   int POS;
   
   GetWindowRect( &DialogRect ); 
   m_pParent->GetWindowRect( &MainRect); 
   m_DialogWidth=DialogRect.right-DialogRect.left;
   POS=MainRect.left - m_DialogWidth; 
   if (POS <0 ){
	   m_pParent->SetWindowPos(NULL, m_DialogWidth +2, MainRect.top, 0, 0, SWP_NOSIZE || SWP_SHOWWINDOW );
       SetWindowPos(NULL,2, MainRect.top, 0, 0, SWP_NOSIZE || SWP_SHOWWINDOW );  
   }
   else{
	   SetWindowPos(NULL, MainRect.left - m_DialogWidth,MainRect.top,0, 0, SWP_NOSIZE || SWP_SHOWWINDOW ); 
   }


}

void CADJUST::OnAutowhitedialog() 
{
	// TODO: Add your control notification handler code here    
	m_pParent->m_pVc3Ctrl->Set(  VC_CTRL_VISCA ,7, 0 );
	Sleep (150);
	m_pParent->m_pVc3Ctrl->Set(  VC_CTRL_VISCA ,CAM_CTL_MANUALCOLOR, 0 );
	Sleep(50);
	m_pParent->m_RedPreviewOffset=0;
	m_RedGainSliderDialog.SetPos(0);
	m_pParent->m_BluePreviewOffset=0;
	m_BlueGainSliderDialog.SetPos(0);
	UpdateData(FALSE);
	
}

void CADJUST::OnWritereg() 
{
	// TODO: Add your control notification handler code here
	CString str;
	int cmd,error;
	
    error=UpdateData(TRUE);
	//str.Format("Register is %d, Value is %d",m_RegisterNumber,m_RegisterValue);
    //MessageBox(str);
	
	m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,m_RegisterNumber, 0 );	
	m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETDECODERREGISTER, 0 );
	
	m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,m_RegisterValue, 0 );	
	m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETDECODERVALUE, 0 );
	//m_pVc3Ctrl->Set(VC_CTRL_VISCA ,cmd, 0 );
   
}

void CADJUST::OnSharpradio1() 
{
	// TODO: Add your control notification handler code here
		// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pParent->m_Sharpness=1;//m_Adjust
	
}

void CADJUST::m_SetAdvancedControls()
{
		
    GetDlgItem(IDC_SHARPRADIO0)->ShowWindow(SW_HIDE );
    GetDlgItem(IDC_SHARPRADIO1)->ShowWindow(SW_HIDE );	
    GetDlgItem(IDC_SHARPRADIO2)->ShowWindow(SW_HIDE );
    GetDlgItem(IDC_SHARPRADIO3)->ShowWindow(SW_HIDE );
	
    GetDlgItem(IDC_STATICIMAGESHARPNESS)->ShowWindow(SW_HIDE );
	GetDlgItem(IDC_STATICFLESHTONE)->ShowWindow(SW_HIDE );
    
    m_BlueGainSliderDialog.ShowWindow(SW_HIDE );
	m_RedGainSliderDialog.ShowWindow(SW_HIDE );
	m_ChromaLevelDialog.ShowWindow(SW_HIDE );

}

void CADJUST::OnAdvancedadjust() 
{
	
	GetWindowRect(&m_Rect);
	
//	CDialogAdvancedControls AdvancedControls(this);	
//	this->ShowWindow(SW_HIDE);
//	AdvancedControls.DoModal();
	}


void CADJUST::test()
{
MessageBox("Works");
}
