#if !defined(AFX_AUTOPOSITION_H__11990F7D_DFDC_449F_972F_BAED4EAF5F5B__INCLUDED_)
#define AFX_AUTOPOSITION_H__11990F7D_DFDC_449F_972F_BAED4EAF5F5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AutoPosition.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAutoPosition dialog
#include "VIDCAP01Dlg.h"

extern double CorrectionFactor[];
extern UINT ZoomFactorD70[];

class CAutoPosition : public CPropertyPage
{
	DECLARE_DYNCREATE(CAutoPosition)

// Construction
public: 
	void UpdateOffsets(int,int);

	
	CBitmap m_bmpZoomOut;
	CBitmap m_bmpZoomIn;
	int m_CalibrationCompensation;

	double m_AutoPositionCorrectionFactor;
//	POINT m_SecondCalibrationPointPosition;

//	POINT m_FirstCalibrationPointPosition;
	CVIDCAP01Dlg * m_pParent;
	CAutoPosition();
	~CAutoPosition();
	void PassPointer(CWnd *);
	void OnReadZoom();

// Dialog Data
	//{{AFX_DATA(CAutoPosition)
	enum { IDD = IDD_AUTOPOSITION };
	int		m_ZoomAutoPosition;
	BOOL	m_PanReverse;
	BOOL	m_TiltReverse;
	CString	m_AutoPositionCorrectionFactorString;
//	BOOL	m_LockZoom;
	int		m_XCenterOffset;
	int		m_YCenterOffset;
	CString	m_EditText;
	UINT	m_EditZoomPosition;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CAutoPosition)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CAutoPosition)
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
//	afx_msg void OnButton1();
	afx_msg void OnDestroy();
	afx_msg void OnChecktiltreverse();
	afx_msg void OnCheckpanrevese();
	afx_msg void OnButtonsetoffset();
	afx_msg void OnButtondefaultoffsets();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AUTOPOSITION_H__11990F7D_DFDC_449F_972F_BAED4EAF5F5B__INCLUDED_)
