// DialogAdvancedControls.cpp : implementation file
//

#include "stdafx.h"
#include "VIDCAP01.h"
#include "DialogAdvancedControls.h"
#include "VAL_USB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialogAdvancedControls dialog


CDialogAdvancedControls::CDialogAdvancedControls(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogAdvancedControls::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogAdvancedControls)
	m_Brightnessstr = _T("");
	m_Contraststr = _T("");
	//}}AFX_DATA_INIT
	m_pParent=(CADJUST*)pParent;

}


void CDialogAdvancedControls::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogAdvancedControls)
	DDX_Control(pDX, IDC_CONTRASTSLIDER, m_ContrastSliderDialog);
	DDX_Control(pDX, IDC_BRIGHTNESSSLIDER, m_BrightnessSliderDialog);
	DDX_Text(pDX, IDC_STATICBRIGHTNESSLEVEL, m_Brightnessstr);
	DDX_Text(pDX, IDC_STATICCONTRASTLEVEL, m_Contraststr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogAdvancedControls, CDialog)
	//{{AFX_MSG_MAP(CDialogAdvancedControls)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogAdvancedControls message handlers

void CDialogAdvancedControls::OnButton1() 
{
	// TODO: Add your control notification handler code here
	 m_pParent->m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,0, 0 );
	     m_pParent->m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETCHROMALEVEL, 0 );
	
}

BOOL CDialogAdvancedControls::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetWindowPos(NULL,m_pParent->m_Rect.left,m_pParent->m_Rect.top, (m_pParent->m_Rect.right- m_pParent->m_Rect.left) , (m_pParent->m_Rect.bottom- m_pParent->m_Rect.top) ,  SWP_SHOWWINDOW ); //SWP_NOSIZE ||
	m_pParent->ShowWindow(SW_SHOW);
	
	InitControls();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDialogAdvancedControls::InitControls()
{
	
	
    m_BrightnessSliderDialog.SetRange(  0,  127,TRUE);
    m_BrightnessSliderDialog.SetPageSize(1);

	
    m_ContrastSliderDialog.SetRange(  0,  127,TRUE);
    m_ContrastSliderDialog.SetPageSize(1);
	
	m_BrightnessSliderDialog.SetPos(m_pParent->m_pParent->m_Brightness);
	m_Brightnessstr.Format("%d",m_BrightnessSliderDialog.GetPos());
	
	m_ContrastSliderDialog.SetPos(m_pParent->m_pParent->m_Contrast);
	m_Contraststr.Format("%d",m_ContrastSliderDialog.GetPos());

	UpdateData(FALSE);
    
}

void CDialogAdvancedControls::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default

	 if ((pScrollBar->GetDlgCtrlID())==IDC_BRIGHTNESSSLIDER){ 
	           m_pParent->m_pParent->m_Brightness = m_BrightnessSliderDialog.GetPos();
			   m_Brightnessstr.Format("%d",m_BrightnessSliderDialog.GetPos());
			   m_pParent->m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,m_BrightnessSliderDialog.GetPos(), 0 );
	           m_pParent->m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETBRIGHTNESSLEVEL, 0 );
		   }
	     else  
	         if ((pScrollBar->GetDlgCtrlID())==IDC_CONTRASTSLIDER){ 
	           m_pParent->m_pParent->m_Contrast = m_ContrastSliderDialog.GetPos();
			   m_Contraststr.Format("%d",m_ContrastSliderDialog.GetPos());			   	 
			   m_pParent->m_pParent->m_pVc3Ctrl->Set(VC_CTRL_RED_BALANCE ,m_ContrastSliderDialog.GetPos(), 0 );
	           m_pParent->m_pParent->m_pVc3Ctrl->Set(VC_CTRL_VISCA ,CAM_CTL_SETCONTRASTLEVEL, 0 );
		   }
	
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
