

///////////////////   Define DLL Function Call  //////////////////////////////////////////////////
extern "C" _declspec(dllexport) int CALLBACK  VALCam_Control(int Message,int Param1,int Param2, int Param3, int Param4);
//////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////// Define Command Constants for DLL ///////////////////////////////
#define VC_InitSystem 0
#define VC_DisplayVideo 1
#define VC_Freeze   2
#define VC_NoVideoDisplay 3
#define VC_LiveCapture 4
#define VC_SetFlashIrisLevel 5
#define VC_SendWindowHandle  6
#define VC_FlashCapture 7

#define VC_TiltUp   8
#define VC_TiltDown 9
#define VC_PanLeft 10
#define VC_PanRight 11
#define VC_PanTiltStop 12
#define VC_ZoomIn 13
#define VC_ZoomOut 14
#define VC_ZoomStop 15  

#define VC_UnloadDriver 20
#define VC_MessageDrainHnd 21
#define VC_DisplayCapture  22
#define VC_SaveCapturedImage     23
#define VC_ColorCorrectImage 24
#define VC_DiscardCapturedImage 25
#define VC_TiltUpSlow   218
#define VC_TiltDownSlow 219
#define VC_PanLeftSlow  220
#define VC_PanRightSlow 221
#define VC_ZoomInSlow   222 
#define VC_ZoomOutSlow  223
#define VC_TiltUpFast   224
#define VC_TiltDownFast 225
#define VC_PanLeftFast  226
#define VC_PanRightFast 227
#define VC_ZoomInFast   228
#define VC_ZoomOutFast  229 

#define VC_RotateLiveDisplay 250

#define VC_SaveIniFile  17
#define VC_CloseCard  20

#define VC_LiveIrisUp 42
#define VC_LiveIrisDown 43

#define VC_SetPreviewDefaults 27
#define VC_SetFlashDefaults 28

#define VC_ReturnLiveRed 31
#define VC_ReturnLiveBlue 32
#define VC_ReturnLiveColor 33
#define VC_ReturnFlashRed 34
#define VC_ReturnFlashBlue 35
#define VC_ReturnFlashColor 36
#define VC_ReturnFlashIris 39
#define VC_ReturnContrast   50
#define VC_ReturnBrightness 51
#define VC_ReturnSharpness  130
#define VC_ReturnFGSharpness 131
#define VC_ReturnAutoWhite 134
#define VC_ReturnRedPaint 135
#define VC_ReturnBluePaint 136



#define VC_SetExposure 132      //Set Brightness level 0-14, Flash Captures are not affected
#define	VC_ReadExposure  133     //Read Brightness level 0-14,Flash Captures are not affected  
#define VC_SetBrightness 116
#define VC_SetContrast   117
#define VC_SetFlashColorCorrection 119

#define VC_ReturnCropStartX 152
#define VC_ReturnCropStartY 153
#define VC_ReturnCropWidth 154
#define VC_ReturnCropHeight 155
#define VC_ReturnFlashColorCorrectionType 157

#define VC_SetCropParameters 156

#define VC_AutoWhite  118
#define VC_SetRedLive 110
#define VC_SetBlueLive 111
#define VC_SetColorLive 112
#define VC_SetRedFlash 113
#define VC_SetBlueFlash 114
#define VC_SetColorFlash 115

#define VC_SetFrameGrabberSharpness 120
#define VC_FastCapture 200

#define VC_ReadZoomPosition 300
#define VC_SetZoomPosition  303
#define VC_SetPanTiltPosition 304
#define VC_SetPanTiltCenter 305

